package lbl.akenti.certs;

import java.io.IOException;
import java.security.GeneralSecurityException;
import java.security.PrivateKey;
import lbl.akenti.certs.elements.AkentiIssuer;
import lbl.akenti.util.UTCTime;

public abstract class AkentiCertGenerator {

  protected AkentiCertificate cert;

  protected AkentiCertGenerator(AkentiCertificate cert) {
    this.cert = cert;
  }

  public void setVersionNumber(int version) {
    cert.setVersionNumber(version);
  }

  public void setUniqueID(String id) {
    cert.setUniqueID(id);
  }

  public void setIssuer(AkentiIssuer issuer) {
    cert.setIssuer(issuer);
  }

  public void setNotBefore(UTCTime notBefore) {
    cert.setNotBefore(notBefore);
  }

  public void setNotAfter(UTCTime notAfter) {
    cert.setNotAfter(notAfter);
  }

  public void sign(String signatureAlg, PrivateKey privateKey)
    throws GeneralSecurityException, IOException {
    cert.sign(signatureAlg, privateKey);
  }
   
  public AkentiCertificate generate() {
    return cert;
  }
}
