package lbl.akenti.dirServices;

import java.net.URL;
import java.security.cert.X509Certificate;
import java.util.Map;
import lbl.akenti.certs.AkentiCertificate;

/**
  * Class <code>CertificateRetrieval</code> provides 
  * applications with a convenient way of retrieving
  * certificates from public directories.
  * 
  * @author  Abdelilah Essiari
  * @version 1, 07/26/2003 
  * @see     java.security.cert.X509Certificate
  * @see     java.net.URL
  * @see     java.util.Map
  * @see     lbl.akenti.certs.AkentiCertificate
  */
public abstract 
class CertificateRetrieval {

  /**
    * Construct this <code>CertificateRetrieval</code>.
    */ 
  protected CertificateRetrieval() {
  }

  /**
    * Retrieves <code>X509Certificate<</code>s.
    */
  public X509Certificate[] retrieveX509Certificates(URL url, Map args) {
    return new X509Certificate[0];
  }

  /**
    * Retrieves <code>AkentiCertificate<</code>s.
    */
  public AkentiCertificate[] retrieveAkentiCertificates(URL url, Map args) { 
    return new AkentiCertificate[0];
  }
}

