package lbl.akenti.gen.controller.attr;

import javax.swing.JPanel;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import lbl.akenti.gen.controller.LBLFrame;
import lbl.akenti.gen.controller.LBLAttrValPane;

import lbl.akenti.gen.common.GenAttribute;
import lbl.akenti.gen.common.GenValue;

/**
  * Allows the user to select an attribute/value pair.
  */
public class AtValueFrame 
  extends LBLFrame implements DocumentListener {

    private LBLAttrValPane attrValPane;

    /** 
      *
      */
    public AtValueFrame(String TITLE, String INSTRUCTIONS) {
      super(TITLE, INSTRUCTIONS);

      JPanel contentPane = (JPanel) getContentPane ();

      attrValPane = new LBLAttrValPane(null, true);
      attrValPane.setDocumentListener(this);
      contentPane.add(
        attrValPane, 
        "Center"
      );
      
      doEnable();
    }

    /*
     * Adds an Attribute.
     */
    public void addAttribute(GenAttribute attribute) {
      attrValPane.addAttribute(attribute);
    }

    /**
      */
    public void changedUpdate(DocumentEvent e)  {
      doEnable();
    }

    /**
      */
    public void insertUpdate(DocumentEvent e)  {
      doEnable();
    }

    /**
      */
    public void removeUpdate(DocumentEvent e) {
      doEnable();
    }
 
    /**
      */
    public void doEnable() {
      if (getAttributeName().equals("")) {
        doEnable(false);
        return;
      } else if (getValueName().equals("")) {
        doEnable(false);
      } else {
        doEnable(true);
      }
    }

    /**
      *
      */
    private void doEnable(boolean enable) {
      if (enable) {
        enableBlueButton("Next");
      } else {
        disableBlueButton("Next");
      } 
    }

    /**
      */
    public GenValue getGenValue() {
      return attrValPane.getGenValue();
    }

    public GenAttribute getGenAttribute() {
      return attrValPane.getGenAttribute();
    }

    /**
      */
    public String getAttributeName() {
      return attrValPane.getAttributeName(); 
    }

    /**
      */
    public String getValueName() {
      return attrValPane.getValueName();
    }

    /**
      */    
    public void clear() {
      attrValPane.clear();
    }
}

