package lbl.akenti.messaging;

import javax.xml.bind.JAXBException;
import lbl.akenti.jaxb.AkentiResponseType;
import lbl.akenti.jaxb.DeletePolicyCertificateResponseType;


/**
 * An sparse response to a delete policy cert request.
 * Empty except for the AkentiMessage.
 *
 * @author Tommaso Sciortino
 */
public final class DeletePolicyCertificateResponse extends AkentiResponse {
  
 /**
   * Constructs a <code>DeletePolicyCertificateResponse</code>.
   * @param uid the id
   * @param mesg the AkentiMessage
   */
  public DeletePolicyCertificateResponse(int uid, AkentiMessage mesg) {
    super(uid, mesg);
  }
  
 /**
   * Constructs this <code>DeletePolicyCertificateResponse</code> from a
   * <code>DeletePolicyCertificateResponseType<code>.
   * @param impl the DeletePolicyCertificateResponseType
   */
  public DeletePolicyCertificateResponse(DeletePolicyCertificateResponseType impl) {
    super(impl);
  }
  
 /**
   * Produces a DeletePolicyCertificateResponseType to encapsulate the data in this object.
   * @throws JAXBException if mandatory data is not present
   * @return the DeletePolicyCertificateResponseType
   */
  protected AkentiResponseType doToJAXBImpl() throws JAXBException {
    return Util.getObjectFactory().createDeletePolicyCertificateResponseGenerated();
  }
}
