package lbl.akenti.messaging;

import javax.xml.bind.JAXBException;
import lbl.akenti.jaxb.AkentiResponseType;
import lbl.akenti.jaxb.DeleteResourceResponseType;

/**
 * An sparse response to a delete resource request.
 * Empty except for the AkentiMessage.
 *
 * @author Tommaso Sciortino
 */
final public
class DeleteResourceResponse extends AkentiResponse {
  
 /**
   * Constructs a <code>DeleteResourceResponse</code>.
   * @param uid the id
   * @param mesg the AkentiMessage
   */
  public DeleteResourceResponse(int uid, AkentiMessage mesg) {
    super(uid, mesg);
  }
  
 /**
   * Constructs this <code>DeleteResourceResponse</code> from a
   * <code>DeleteResourceResponseType<code>.
   * @param impl the DeleteResourceResponseType
   */
  public DeleteResourceResponse(DeleteResourceResponseType impl) {
    super(impl);
  }
  
 /**
   * Produces a DeleteResourceResponseType to encapsulate the data in this object.
   * @throws JAXBException if mandatory data is not present
   * @return the DeleteResourceResponseType
   */
  protected AkentiResponseType doToJAXBImpl() throws JAXBException {
    return Util.getObjectFactory().createDeleteResourceResponseGenerated();
  }
}
