/*
 * RestrictedAttributes.java
 *
 * Created on June 29, 2004, 9:15 AM
 */

package lbl.akenti.messaging;

import javax.xml.bind.JAXBException;
import lbl.akenti.jaxb.RestrictedAttributeType;

/**
 * Descibes a Name/Value pair indicating a restriction on the capabilities
 * of a user.
 * @author Tommaso Sciortino
 */
public class RestrictedAttribute {
  
 /**
   * The Name
   */
  String name;
  
 /**
   * The Value
   */  
  String  value;
  
 /**
   * Creates a new instance of <code>RestrictedAttributes</code>.
   * @param name the Name
   * @param value the Value
   */
  public RestrictedAttribute(String name, String value) {
    this.name = name;
    this.value = value;
  }
  
 /**
   * JAXB  STUFF.
   * TODO: Efficiency
   */
  RestrictedAttribute(RestrictedAttributeType impl) {
    value = impl.getValue();
    name = impl.getName();
  }
  
 /**
   * Returns the Name.
   * @return the Name
   */  
  public String getName() {
    return name;
  }
  
 /**
   * Returns the Value.
   * @return the Value
   */  
  public String getValue() {
    return value;
  }
  
 /**
   * Produces a RestrictedAttributeType to encapsulate the data in this object.
   * @throws JAXBException if mandatory data is not present
   * @return the RestrictedAttributeType
   */
  public RestrictedAttributeType toJAXBImpl() throws JAXBException {
    RestrictedAttributeType impl = Util.getObjectFactory().createRestrictedAttributeType();
    impl.setValue(value);
    impl.setName(name);
    
    return impl;
  }
  
}
