package lbl.akenti.messaging;
 
import javax.xml.bind.JAXBException;
import lbl.akenti.jaxb.AkentiResponseType;
import lbl.akenti.jaxb.UploadPolicyCertificateResponseType;
 
/**
 * A sparse response to a upload Certificate request.
 * @author Tommaso Sciortino
 */
final public
class UploadPolicyCertificateResponse extends AkentiResponse {
 
 /**
   * Creates a UploadPolicyCertificateResponse.
   * @param id the id
   * @param mesg the AkentiMessage
   */
  public UploadPolicyCertificateResponse(int id, AkentiMessage mesg) {
     super(id, mesg);
  }
 
 /**
   * Creates a UploadPolicyCertificateResponse from a  Creates a
   * UploadPolicyCertificateResponseType
   * @param impl the UploadPolicyCertificateResponseType
   */
  public UploadPolicyCertificateResponse(UploadPolicyCertificateResponseType impl) {
    super(impl);
  }
 
 /**
   * Produces a UploadPolicyCertificateResponseType to encapsulate the data in this object.
   * @throws JAXBException if mandatory data is not present
   * @return the UploadPolicyCertificateResponseType
   */
  protected AkentiResponseType doToJAXBImpl() throws JAXBException {
    return Util.getObjectFactory().createUploadPolicyCertificateResponseGenerated();
  }
}

