/**
 *  Simple JOptionPane widget to get input from the user
 *  @author Jordan Thompson (JordanCThompson@yahoo.com)
 */

package lbl.akenti.policyManager.widgets;

public class InputPane extends javax.swing.JOptionPane {
    private boolean userApproved;
    // Variables declaration - do not modify
    private javax.swing.JPanel button_panel;
    private javax.swing.JButton cancel_button;
    private javax.swing.JLabel label;
    private javax.swing.JPanel main_panel;
    private javax.swing.JButton ok_button;
    private javax.swing.JTextField textField;
    // End of variables declaration
    
    public InputPane(String label) {
        initComponents(label);
    }
    
    private void initComponents(String aLabel) {
        setLayout(new java.awt.BorderLayout());
        
        java.awt.GridBagConstraints gridBagConstraints;
        
        main_panel = new javax.swing.JPanel();
        label = new javax.swing.JLabel();
        textField = new javax.swing.JTextField();
        button_panel = new javax.swing.JPanel();
        ok_button = new javax.swing.JButton();
        cancel_button = new javax.swing.JButton();
        
        main_panel.setLayout(new java.awt.GridBagLayout());
        
        label.setText(aLabel);
        main_panel.add(label, new java.awt.GridBagConstraints());
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 100;
        main_panel.add(textField, gridBagConstraints);
        
        add(main_panel, java.awt.BorderLayout.CENTER);
        
        button_panel.setLayout(new java.awt.GridBagLayout());
        
        ok_button.setText("OK");
        ok_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ok_buttonActionPerformed(evt);
            }
        });
        
        button_panel.add(ok_button, new java.awt.GridBagConstraints());
        
        cancel_button.setText("CANCEL");
        cancel_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancel_buttonActionPerformed(evt);
            }
        });
        
        button_panel.add(cancel_button, new java.awt.GridBagConstraints());
        
        add(button_panel, java.awt.BorderLayout.SOUTH);
        
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-304)/2, (screenSize.height-154)/2, 304, 154);
    }
    
    private void cancel_buttonActionPerformed(java.awt.event.ActionEvent evt) {
        userApproved = false;
        setValue(GenConsts.AK_CANCEL_VALUE);
    }
    
    private void ok_buttonActionPerformed(java.awt.event.ActionEvent evt) {
        userApproved = true;
        setValue(GenConsts.AK_CANCEL_VALUE);
    }
    
    public boolean getUserApproved() {
        return userApproved;
    }
    
    public void setText(String text) {
        textField.setText(text);
    }
    public String getText() {
        return textField.getText().trim();
    }
}
