/**
 *  @author Jordan Thompson (JordanCThompson@yahoo.com)
 */
package lbl.akenti.policyManager.widgets;

public class TimeInputPane extends javax.swing.JOptionPane {
    
    public long lifeTime;
    public boolean userApproved;
    // Variables declaration - do not modify
    private javax.swing.JPanel button_panel;
    private javax.swing.JButton cancel_button;
    private javax.swing.JPanel main_panel;
    private javax.swing.JButton ok_button;
    private javax.swing.JComboBox time_ComboBox;
    private javax.swing.JLabel time_label;
    // End of variables declaration
    
    public TimeInputPane() {
        initComponents();
        initValues();
    }
    
    public void initValues() {
        for (int i = 0; i < DURATION.length; i++) {
            time_ComboBox.addItem( DURATION[i] );
        }
    }
    
    private void initComponents() {
        setLayout(new java.awt.BorderLayout());
        java.awt.GridBagConstraints gridBagConstraints;
        
        main_panel = new javax.swing.JPanel();
        time_label = new javax.swing.JLabel();
        time_ComboBox = new javax.swing.JComboBox();
        button_panel = new javax.swing.JPanel();
        ok_button = new javax.swing.JButton();
        cancel_button = new javax.swing.JButton();
        
        main_panel.setLayout(new java.awt.GridBagLayout());
        
        time_label.setText("TIME DURATION");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.ipadx = 20;
        main_panel.add(time_label, gridBagConstraints);
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.ipadx = 90;
        main_panel.add(time_ComboBox, gridBagConstraints);
        
        add(main_panel, java.awt.BorderLayout.CENTER);
        
        button_panel.setLayout(new java.awt.GridBagLayout());
        
        ok_button.setText("OK");
        ok_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ok_buttonActionPerformed(evt);
            }
        });
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.RELATIVE;
        gridBagConstraints.gridheight = java.awt.GridBagConstraints.RELATIVE;
        button_panel.add(ok_button, gridBagConstraints);
        
        cancel_button.setText("CANCEL");
        cancel_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancel_buttonActionPerformed(evt);
            }
        });
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 13;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        button_panel.add(cancel_button, gridBagConstraints);
        
        add(button_panel, java.awt.BorderLayout.SOUTH);
        
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-277)/2, (screenSize.height-129)/2, 277, 129);
    }
    
    private void cancel_buttonActionPerformed(java.awt.event.ActionEvent evt) {
        userApproved = false;
        setValue(GenConsts.AK_CANCEL_VALUE);
    }
    
    private void ok_buttonActionPerformed(java.awt.event.ActionEvent evt) {
        userApproved = true;
        setValue(GenConsts.AK_CANCEL_VALUE);
    }
    
    public long getLifeTime() {
        String time = (String) time_ComboBox.getSelectedItem();
        
        if (time.equals(DURATION[0])) {  // one hour
            return (long)1000*60*60;
        }
        else if (time.equals(DURATION[1])) {  // one day
            return (long)1000*60*60*24;
        }
        else if (time.equals(DURATION[2])) {  // one week
            return (long)1000*60*60*24*7;
        }
        else if (time.equals(DURATION[3])) {  // one month
            return (long)1000*60*60*24*30;
        }
        else if (time.equals(DURATION[4])) {  //one year
            return (long)1000*60*60*24*365;
        }
        else {  //two years
            return (long)1000*60*60*24*365*2;
        }
    }
    
    public boolean getUserApproved() {
        return userApproved;
    }
    
    public static final String[] DURATION = {
        "1 Hour", "1 Day", "1 Week", "1 Month", "1 Year", "2 Years"
    };
}
