package lbl.akenti.policyManager.widgets.viewer;

import java.beans.PropertyVetoException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.JDesktopPane;
import lbl.akenti.messaging.CertificateInfo;
import lbl.akenti.messaging.CheckPolicyResponse;
import lbl.akenti.messaging.PolicyInfo;
import lbl.akenti.policyManager.widgets.LBLPanel;
import lbl.akenti.policyManager.widgets.LBLTopFrame;
import lbl.akenti.policyManager.widgets.WrapUtil;

import lbl.akenti.policyManager.base.GenInfo;

import java.awt.GridBagLayout;
import javax.swing.JFileChooser;
import java.io.File;
/**
 * Allows the user to choose a resource and/or view its respective
 * UseConditions
 */

public class LBLPolUCChoosePanel
extends LBLPanel implements ActionListener, ListSelectionListener {
    
    private JList polList;
    private JList useCondList;
    
    private JButton polButton;
    private JButton useCondButton;
    private JButton attrButton;
    private CheckPolicyResponse resp;
    
    private JDesktopPane desktop;
    
    private GenInfo info;
    private LBLTopFrame component;
    public LBLPolUCChoosePanel(LBLTopFrame parent, String header, JDesktopPane aDesktop) {
        super(parent, header);
        component = parent;
        desktop = aDesktop;
        
        polList = new JList(new DefaultListModel());
        polList.setSelectionMode(0);
        polList.addListSelectionListener(this);
        JLabel polLabel = new JLabel("Policy Certificates");
        
        polButton = new JButton("Open");
        polButton.setEnabled(false);
        polButton.setActionCommand("OpenPol");
        polButton.addActionListener(this);
        JPanel polSet = WrapUtil.wrapComponents(new JScrollPane(polList), polButton);
        JPanel polPane = WrapUtil.wrapVertical(polLabel, polSet);
        
        useCondList = new JList(new DefaultListModel());
        useCondList.setSelectionMode(0);
        useCondList.addListSelectionListener(this);
        JLabel useCondLabel = new JLabel("Use Condition Certificates");
        
        useCondButton = new JButton("Open");
        useCondButton.setEnabled(false);
        useCondButton.setActionCommand("OpenUC");
        useCondButton.addActionListener(this);
        JPanel useCondSet = WrapUtil.wrapComponents(new JScrollPane(useCondList), useCondButton);
        JPanel useCondPane = WrapUtil.wrapVertical(useCondLabel, useCondSet);
        
        JLabel attrLabel = new JLabel("Attribute Certificates");
        attrButton = new JButton("Open");
        attrButton.setEnabled(true);
        attrButton.setActionCommand("OpenAttr");
        attrButton.addActionListener(this);
        JPanel attrPane = WrapUtil.wrapHorizontal(attrLabel, attrButton);
        JPanel attrButtonPane = new JPanel(new GridBagLayout());
        attrButtonPane.add(attrPane);
        
        JPanel listPane = WrapUtil.wrapVertical(polPane, useCondPane);
        JPanel attrListPane = WrapUtil.wrapVertical(listPane, attrButtonPane);
        
        JPanel mainPanel = WrapUtil.wrapVertical(listPane, attrListPane);
        
        add(mainPanel, "Center");
        
    }
    
    /**
     * Returns button labels specific for this frame
     */
    protected String [] getButtonLabels(int type) {
        if (type == 2) {
            return new String[] { "Help", "Back", "Exit"};
        } else {
            return getButtonLabels(type);
        }
    }
    
    /**
     * Called whenever an item is chosen on a list
     */
    public void valueChanged(ListSelectionEvent l) {
        if (l.getSource().equals(polList)) {
            updateUCList();
        } else {
            doEnable();
        }
    }
    
    public void actionPerformed(ActionEvent event) {
        String cmd = event.getActionCommand();
        
        if (cmd.equals("OpenPol")) {
            
            int index = polList.getSelectedIndex();
            PolicyInfo[] polRespArray = resp.toPolicyInfosArray();
            PolicyInfo p = polRespArray[index];
            Iterator certResps = p.getCertificateInfos();
            Iterator certInfos = p.getCertificateInfos();
            CertificateInfo c = (CertificateInfo) certInfos.next();
            CertInfoViewFrame frame = new CertInfoViewFrame(c, this);
            
            java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
            frame.setBounds((screenSize.width-600)/2, (screenSize.height-400)/2, 600, 400);
            frame.setVisible(true);
            frame.setLocation(100, 100);
            frame.setCAInfos(info);
            desktop.add(frame);
            try {
                frame.setSelected(true);
            } catch (PropertyVetoException e) {}
            
        } else if (cmd.equals("OpenUC")) {
            
            int polIndex = polList.getSelectedIndex();
            PolicyInfo[] polInfoArray = resp.toPolicyInfosArray();
            PolicyInfo p = polInfoArray[polIndex];
            int useCondIndex = useCondList.getSelectedIndex() + 1;
            CertificateInfo[] certInfoArray = p.toCertificateInfosArray();
            CertificateInfo c = certInfoArray[useCondIndex];
            CertInfoViewFrame frame = new CertInfoViewFrame(c, this);
            
            java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
            frame.setBounds((screenSize.width-600)/2, (screenSize.height-400)/2, 600, 400);
            frame.setVisible(true);
            frame.setLocation(100, 100);
            frame.setCAInfos(info);
            desktop.add(frame);
            try {
                frame.setSelected(true);
            } catch (PropertyVetoException e) {}
            
        } else if (cmd.equals("OpenAttr")) {
            JFileChooser fileChooser = new JFileChooser();
            fileChooser.setDialogTitle("Select the Attribute Certificate you want to edit");
            fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
            int clientResponse = fileChooser.showDialog(this, "Select");
            
            if (clientResponse == fileChooser.APPROVE_OPTION) {
                fileChooser.getSelectedFile().getAbsolutePath();
                File file = fileChooser.getSelectedFile();
                CertInfoViewFrame frame = new CertInfoViewFrame(file.getAbsolutePath(), this);
                
                java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
                frame.setBounds((screenSize.width-600)/2, (screenSize.height-400)/2, 600, 400);
                frame.setVisible(true);
                frame.setLocation(100, 100);
                frame.setCAInfos(info);
                desktop.add(frame);
                try {
                    frame.setSelected(true);
                } catch (PropertyVetoException e) {}
            }
        } else {
            throw new RuntimeException(cmd + " not supported");
        }
    }
    
    public void createAdvancedFrame(String header) {
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle(header);
        fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
        int clientResponse = fileChooser.showDialog(this, "Select");
        
        if (clientResponse == fileChooser.APPROVE_OPTION) {
            fileChooser.getSelectedFile().getAbsolutePath();
            File file = fileChooser.getSelectedFile();
            CertInfoViewFrame frame = new CertInfoViewFrame(file.getAbsolutePath(), this);
            
            java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
            frame.setBounds((screenSize.width-600)/2, (screenSize.height-400)/2, 600, 400);
            frame.setVisible(true);
            frame.setLocation(100, 100);
            frame.setCAInfos(info);
            desktop.add(frame);
            try {
                frame.setSelected(true);
            } catch (PropertyVetoException e) {}
        }
    }
    /**
     * Enables/disables buttons to view certificates
     */
    public void doEnable() {
        polButton.setEnabled(polList.getSelectedIndex() != -1);
        useCondButton.setEnabled(useCondList.getSelectedIndex() != -1);
    }
    
    
    /**
     * Updates useCondList to reflect UCs for currently chosen policy
     * Called upon changing the selected policy
     */
    public void updateUCList() {
        
        DefaultListModel model = (DefaultListModel) useCondList.getModel();
        model.clear();
        if (polList.getSelectedIndex() != -1) {
            PolicyInfo[] polRespArray = resp.toPolicyInfosArray();
            PolicyInfo p = polRespArray[polList.getSelectedIndex()];
            Iterator certInfos = p.getCertificateInfos();
            CertificateInfo c = (CertificateInfo) certInfos.next();
            while (certInfos.hasNext()) {
                c = (CertificateInfo) certInfos.next();
                model.addElement(c);
            }
        }
        doEnable();
    }
    
    /**
     * Load in proper CheckPolicyResponse, begin processing information
     */
    public void setCheckPolicyResponse(CheckPolicyResponse c) {
        if (c == null) {
            throw new RuntimeException("No ResourcePolicy found");
        }
        resp = c;
        processLists();
    }
    
    /**
     * Populate the policy list based on the current CheckPolicyResponse
     */
    public void processLists() {
        DefaultListModel model = (DefaultListModel) polList.getModel();
        model.clear();
        Iterator polInfos = resp.getPolicyInfos();
        while (polInfos.hasNext()) {
            PolicyInfo p = (PolicyInfo) polInfos.next();
            Iterator certInfos = p.getCertificateInfos();
            // first certificate in PolicyResponse must be policy
            CertificateInfo certInfo = (CertificateInfo) certInfos.next();
            if (certInfo.getAkentiCertificate().getType().equals("UseCondition")) {
                throw new RuntimeException("No Policy at beginning of PolicyResponse");
            }
            model.addElement(certInfo);
        }
    }
    
    public void setCAInfos(GenInfo genInfo) {
        info = genInfo;
    }
    
    /**
     * Clears the frame
     */
    public void clear() {
        DefaultListModel model = (DefaultListModel) polList.getModel();
        model.clear();
        model = (DefaultListModel) useCondList.getModel();
        model.clear();
        //viewTable.clear();
        doEnable();
    }
}
