package lbl.akenti.servers.AKMonitor.gui;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.border.Border;
import javax.swing.border.EmptyBorder;
import javax.swing.border.BevelBorder;
import javax.swing.border.CompoundBorder;
import java.awt.BorderLayout;

/**
  * A simple textarea.
  */
public class TextArea extends JScrollPane {
  JFrame frame;
  JTextArea area;
   
  /* 
   * Contructor.
   */
  public TextArea() {
    textAreaInit();
  }

  /*
   * Use ths contructor to a textarea int its own frame.
   **/
  public TextArea(String title) {
    textAreaInit();
    frame = new JFrame(title);
    frame.setContentPane(this); 
    frame.pack();
  }

  /*
   * intialize.
   **/
  protected void textAreaInit() {
    Border b;

    setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
    b = new EmptyBorder(10, 10, 10, 10);
    b = new CompoundBorder(b, new BevelBorder(BevelBorder.RAISED));
    setBorder(b);

    area = new JTextArea(10, 20);
    b = new EmptyBorder(5, 5, 5, 5);
    b = new CompoundBorder(new BevelBorder(BevelBorder.LOWERED), b);
    area.setBorder(b);
    setViewportView(area);
  }

  /*
   * this is really usefull if the area is in its own frame.
   **/
  public void setVisible(boolean visible) {
    if (frame == null) {
      super.setVisible(visible);
    } else {
      frame.setVisible(visible);
    }
  }

  public void setText(Object obj) {
    area.setText(obj.toString());
  }

  /*
   * @see JTextArea#setText(String)
   **/
  public void setText(String text) {
    area.setText(text);
  }

  public void append(Object obj) {
    area.append(obj.toString());
  }

  /*
   * @see JTextArea#append(String)
   **/
  public void append(String text) {
    area.append(text);
  }
  
  public void dispose() {
    if (frame != null) {
      frame.dispose();
    }
  }
}
