package lbl.akenti.servers.AKMonitor.util;

import java.util.Hashtable;
import java.util.Vector;
import java.io.IOException;
import java.text.ParseException;

/**
  * Holds all the keys.
  */
public class KeyFile {
  private Hashtable infos;
  
  private static KeyFile keyFile = null;

  private KeyFile(){
    infos = new Hashtable();
  }

  /**
    * Returns the <code>AKInfo</code> corresponding to <code>key</code>.
    *
    */
  public AKInfo getAKInfo(String key) {
    if (key == null) {
      throw new IllegalArgumentException();
    }

    AKInfo aki = null;

    if (infos.containsKey(key)) {
      aki = (AKInfo) infos.get(key);
    }

    return aki;
  }   

  /**
    * Adds an <code>AKInfo</code> to <code>Hashinfos</code>
    */
  private void putAKInfo(AKInfo akInfo){
    infos.put(akInfo.getKey(), akInfo);
  }

  /**
    * Method to get the unique keyFile of this class
    */
  public static KeyFile getKeyFile() {
    return keyFile;
  }

  /**
    * Initializes the key infos from a file.
    */
  public static boolean initKeyFile(String filename) 
  throws ParseException, IOException {
    if (keyFile == null) {
      Vector res = ParseKeyFile.doParse(filename);
      keyFile = new KeyFile();

      for(int i = 0; i < res.size(); ++i) {
        keyFile.putAKInfo((AKInfo) res.get(i));
      }

      return true;  
    }

    return false;
  }
}

