package lbl.akenti.servers.AKMonitor.util;

import java.util.Vector;
import java.util.StringTokenizer;

import java.text.ParseException;
import java.io.FileNotFoundException;
import java.io.IOException;

import java.io.FileReader;
import java.io.BufferedReader;
import java.io.LineNumberReader;

/**
  * simple class to parse a KeyFile into AKInfo Object
  * @author Guillaume Farret
  * @version August 2001
  */
public class ParseKeyFile {

  private static String[] KEYS = {"description","key","success","fail"};//order is important
  private static LineNumberReader reader = null;

/**
  * method to parse a given file into a Vector containing AKInfo Object
  */
  public static Vector doParse(String filename) throws ParseException,FileNotFoundException,IOException {
 
    reader = new LineNumberReader(new BufferedReader(new FileReader(filename)));
    
    Vector result = new Vector();

    while(!isEOF()){
      
      if (!contain("BEGIN AKINFO")) {
        reader.readLine();
        continue;
      }
      reader.readLine();

      AKInfo info = new AKInfo();
      int i=0;

      while(!contain("END AKINFO")){

        if(contain("=")){
          StringBuffer lineB = new StringBuffer();
          
          do{
            lineB.append(reader.readLine().trim()).append('\n');
          }while(!contain("=")&&!contain("END AKINFO"));

          String line = lineB.toString().trim();

          StringTokenizer st = new StringTokenizer(line, "=");
          
          if (line.indexOf(KEYS[i])!=-1 && st.countTokens()==2){
            st.nextToken();
            switch(i){
              case 0:info.setDescription(st.nextToken().trim());break;
              case 1:info.setKey(st.nextToken().trim());break;
              case 2:info.setSuccess(st.nextToken().trim());break;
              case 3:info.setFail(st.nextToken().trim());break;
            }
            i++;
          }else{
            throw new ParseException("error line :", reader.getLineNumber());
          }
        }else{
          reader.readLine();
          continue;
        }
      }
      result.addElement(info);
    }
    return result;
  }


/**
  * does the next line of the reader contain a given String
  * @param s string to search in the nex line of the reader
  */
  private static boolean contain(String s) throws IOException {
    boolean ret = true; 
    reader.mark(4096);
    String line = reader.readLine();
    reader.reset();

    if (line == null || line.indexOf(s)==-1 || line.startsWith("#")) ret = false;
    return ret; 
  }
  
/**
  * are we at the end of file ?
  */  
  private static boolean isEOF() throws IOException {
    boolean ret = false;
    reader.mark(4096);
    String line = reader.readLine();
    reader.reset();
    if (line==null) ret = true;
    return ret;
  }

/**
  * testing
  */
  public static void main (String[] args) {
    try{
      Vector res = doParse(args[0]);
      
      for (int i=0; i<res.size();i++){
        AKInfo aki = (AKInfo)(res.get(i));
        System.out.println("key         =   " + aki.getKey());
        System.out.println("description =   " + aki.getDescription());
        System.out.println("success     =   " + aki.getSuccess());
        System.out.println("fail        =   " + aki.getFail());
        System.out.println();
      }

    }
    catch(ParseException e){System.out.println("parse error, line: "+e.getErrorOffset());}
    catch(Exception e){System.out.println("error: " + e.getClass().getName() +" " +e.getMessage());}
  }
}
