package lbl.akenti.servers.CacheManager;

import java.io.PrintWriter;
import java.io.LineNumberReader;
import java.io.IOException;
import java.text.ParseException;

/**
  *
  */
public class CacheResponse extends CacheRequest {

  private String status;

  /**
    *
    */
  public CacheResponse() {
    this("NO_METHOD");
  }

  /**
    *
    */
  public CacheResponse(String method) {
    super(method);
    this.status = "NO_STATUS";
  }
  
  public CacheResponse(CacheRequest req) {
    super(req.getMethod());
    setRootResourceName(req.getRootResourceName());
    setCertHash(req.getCertHash());
    setDirName(req.getDirName());
  }

  /**
    *
    */
  public void setStatus(String status) {
    if (status == null || status.length() == 0) {
      throw new IllegalArgumentException();
    }

    this.status = status;
  }

  /**
    *
    */
  public String getStatus() {
    return status; 
  }

  protected void writeHeaderInfo(PrintWriter pw) {
    super.writeHeaderInfo(pw);
    pw.println("STATUS: " + status);
  }

  protected void readHeaderInfo(LineNumberReader lnr) throws ParseException, IOException {
    super.readHeaderInfo(lnr);

    String line = readLine(lnr);

    status = parse("STATUS", line, lnr.getLineNumber());
  }
}
