package lbl.akenti.servers.CacheManager;

import java.util.Date;
import java.text.SimpleDateFormat;
import java.text.ParseException;

/**
  *
  */
public class UtcTime {

  private static String DEFAULT_FORMAT = "yyMMddHHmmss'Z'";
  private static String XML_FORMAT = "yyyy-MM-dd'T'HH:mm:ss'Z'";

  private Date date;

  /**
    */
  public UtcTime() {
    date = new Date();
  }

  /**
    */
  public UtcTime(long offset) {
    date = new Date();
    date.setTime(date.getTime() + offset);
  }

  /**
    *
    */
  public UtcTime(UtcTime utc, long offset) {
    date = new Date();
    date.setTime(utc.getTime() + offset);
  }

  /**
    *
    */
  public UtcTime(String rep) throws ParseException {
      if(rep.length() > 13){
	  date = new SimpleDateFormat(XML_FORMAT).parse(rep);
      }else{
	  date = new SimpleDateFormat(DEFAULT_FORMAT).parse(rep);
      }
  }

  /**
    *
    */
  public UtcTime(String format, String rep) throws ParseException {
    date = new SimpleDateFormat(format).parse(rep);
  }

  /**
    *
    */
  public int compareTo(UtcTime utc) {
    return (int) (getTime() - utc.getTime());
  }

  /**
    *
    */
  public long getTime() {
    return date.getTime();
  }

  /**
    *
    */
  public String toString() {
    SimpleDateFormat sdf  = new SimpleDateFormat(XML_FORMAT);

    return sdf.format(date);
  }

}
