
/*
 */
package lbl.akenti.util;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.Key;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.KeyStoreSpi;
import java.security.NoSuchAlgorithmException;
import java.security.UnrecoverableKeyException;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.util.Date;
import java.util.Enumeration;
import java.util.Hashtable;

public class P8KeyStore extends KeyStore {
   public P8KeyStore() {
     super(new P8KeyStoreSpi(), null, null);
   }

   static class P8KeyStoreSpi extends KeyStoreSpi {
     Hashtable table = new Hashtable();
    
     P8KeyStoreSpi() {
     }

     public Key engineGetKey(String alias, char[] password)
       throws NoSuchAlgorithmException, UnrecoverableKeyException {
       Object [] a = (Object []) table.get(alias);
       return (Key) a[0];
     }

     public Certificate[] engineGetCertificateChain(String alias) {
       Object [] a = (Object []) table.get(alias);

       return (Certificate[]) a[1];
     }

     public Certificate engineGetCertificate(String alias) {
       return (Certificate) table.get(alias);
     }

     public Date engineGetCreationDate(String alias)  {
       throw new RuntimeException("UNSUPPORTED");
     }

     public void engineSetKeyEntry(String alias, Key key,
 	                           char[] password,
	  			   Certificate[] chain)
       throws KeyStoreException {
       table.put(alias, new Object[] { key, chain });
     }

     public void engineSetKeyEntry(String alias, byte[] key, Certificate[] chain)
       throws KeyStoreException {
       throw new RuntimeException("UNSUPPORTED");
     }

     public void engineSetCertificateEntry(String alias, Certificate cert)
       throws KeyStoreException {
       table.put(alias, cert);
     }

     public void engineDeleteEntry(String alias) throws KeyStoreException  {
       throw new RuntimeException("UNSUPPORTED");
     }

     public Enumeration	engineAliases() {
       return table.keys();
     }

     public boolean engineContainsAlias(String alias) {
       return table.containsKey(alias);
     }

     public int engineSize() {
       return table.size();
     }

     public boolean engineIsKeyEntry(String alias) {
       return !engineIsCertificateEntry(alias);
     }

     public boolean engineIsCertificateEntry(String alias) {
       return table.get(alias) instanceof Certificate;
     }

     public String engineGetCertificateAlias(Certificate cert) {
       throw new RuntimeException("UNSUPPORTED");
     }

     public void engineStore(OutputStream stream, char[] password)
       throws IOException, NoSuchAlgorithmException, CertificateException {
       throw new RuntimeException("UNSUPPORTED");
     }

     public void engineLoad(InputStream stream, char[] password)
       throws IOException, NoSuchAlgorithmException, CertificateException {
     }
  }
}

