package lbl.akenti.policyManager.base;

import lbl.akenti.certs.elements.DistinguishedName;
import lbl.akenti.certs.elements.Directory;
import java.util.HashSet;

/**
  */
public class GenCa { 
    private HashSet idDirectories;
    private DistinguishedName dn;
    
    /**
      * Constructor.
      *
      */
    public GenCa(DistinguishedName dn) {
	if (dn == null) {
	    throw new IllegalArgumentException();
	}
	
	this.dn = dn;
	idDirectories = new HashSet();
    }
    
    public DistinguishedName getDistinguishedName() {
	return dn;
    }
    
    public void addDir(Directory dir) {
	idDirectories.add(dir);
    }
    
    public void addDirs(Directory []dirs) {
	for (int i = 0; i < dirs.length; i++) {
	    idDirectories.add(dirs[i]);
	}
    }
    
    public Directory[] getDirs() {
        Directory []temp = new Directory[idDirectories.size()];
	
	idDirectories.toArray(temp);
	return temp;
    }
    
    public String toString() {
	return dn.getValue("CN");
    }
    
    public boolean equals(Object o) {
	if (o instanceof GenCa) {
	    GenCa ca = (GenCa) o;
	    
	    return dn.equals(ca.dn);
	}
	
	return false;
    }
    
    public int hashCode() {
	return dn.hashCode();
    }
    
    public String paramString() {
	StringBuffer sb = new StringBuffer();
	
	sb.append("[");
	sb.append("dn = ");
	sb.append(dn.paramString());
	sb.append(",");
	sb.append(idDirectories);
	sb.append("]");
	return sb.toString();
    }
}

